name: WebSocket server
on:
  push:
    branches:
      - "master"
      - "[0-9].[0-9]*"
    paths:
      - "superset-websocket/**"
  pull_request:
    paths:
      - "superset-websocket/**"
    types: [synchronize, opened, reopened, ready_for_review]

# cancel previous workflow jobs for PRs
concurrency:
  group: ${{ github.workflow }}-${{ github.event.pull_request.number || github.run_id }}
  cancel-in-progress: true

jobs:
  app-checks:
    runs-on: ubuntu-22.04
    steps:
      - name: "Checkout ${{ github.ref }} ( ${{ github.sha }} )"
        uses: actions/checkout@v4
        with:
          persist-credentials: false
      - name: Install dependencies
        working-directory: ./superset-websocket
        run: npm ci
      - name: eslint
        working-directory: ./superset-websocket
        run: npm run eslint -- . --quiet
      - name: typescript checks
        working-directory: ./superset-websocket
        run: npm run type
      - name: prettier
        working-directory: ./superset-websocket
        run: npm run prettier-check
      - name: unit tests
        working-directory: ./superset-websocket
        run: npm run test
      - name: build
        working-directory: ./superset-websocket
        run: npm run build
